--- modules/demux/playlist/asx.c.original	2009-12-18 15:06:08.000000000 +0100
+++ modules/demux/playlist/asx.c	2009-12-18 15:55:02.000000000 +0100
@@ -286,7 +286,8 @@
         int i_duration = 0;
 
         psz_parse = strcasestr( psz_parse, ">" );
-
+	input_item_t * uniq_entry_ad_backup = NULL;
+	int i_inserted_entries = 0;
         while( psz_parse && ( psz_parse = strcasestr( psz_parse, "<" ) ) )
         {
             if( !strncasecmp( psz_parse, "<!--", 4 ) )
@@ -487,6 +488,7 @@
                 {
                     msg_Err( p_demux, "end of entry without start?" );
                     continue;
+
                 }
 
                 if( !psz_href )
@@ -494,8 +496,8 @@
                     msg_Err( p_demux, "entry without href?" );
                     continue;
                 }
-
-                if( p_sys->b_skip_ads && b_skip_entry )
+		// We will decide whether the entry is an ad, only if we have other entries
+                if( p_sys->b_skip_ads && b_skip_entry && i_inserted_entries != 0 )
                 {
                     char *psz_current_input_name = input_item_GetName( p_current_input );
 
@@ -544,8 +546,20 @@
                         if( psz_copyright_entry ) input_item_SetCopyright( p_entry, psz_copyright_entry );
                         if( psz_moreinfo_entry ) input_item_SetURL( p_entry, psz_moreinfo_entry );
                         if( psz_abstract_entry ) input_item_SetDescription( p_entry, psz_abstract_entry );
-                        input_item_AddSubItem( p_current_input, p_entry );
-                        vlc_gc_decref( p_entry );
+			i_inserted_entries++;
+			if ( p_sys->b_skip_ads && b_skip_entry )
+			{
+			  // We put the entry as a backup
+			  uniq_entry_ad_backup = p_entry;
+			} else {
+			  if (uniq_entry_ad_backup != NULL){
+			      uniq_entry_ad_backup = NULL;
+			      vlc_gc_decref( uniq_entry_ad_backup );
+			  }
+			  input_item_AddSubItem( p_current_input, p_entry );
+			  vlc_gc_decref( p_entry );
+			}
+                        
                     }
                     free( psz_current_input_name );
                 }
@@ -698,6 +712,13 @@
             }
             else psz_parse++;
         }
+	
+	if (uniq_entry_ad_backup != NULL){
+	    msg_Dbg( p_demux, "added unique entry even if ad");
+	    // If ASX contains a unique entry, we add it, it is probably not an ad
+	    input_item_AddSubItem( p_current_input, uniq_entry_ad_backup );
+	    vlc_gc_decref( uniq_entry_ad_backup);
+	}
 #if 0
 /* FIXME Unsupported elements */
             PARAM
